/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Wdg.h 1547 2015-07-08 03:48:31Z suzuki-kawaguchi $
 */

/* [WDG061] Wdg.h */

#ifndef WDG_H
#define WDG_H

#include "Os.h"
#include "Wdg_Cfg.h"
#include "WdgIf_Types.h"

/*
 *  [WDG010] 顼
 */
#define WDG_E_DRIVER_STATE	0x10U
#define WDG_E_PARAM_MODE	0x11U
#define WDG_E_PARAM_CONFIG	0x12U
#define WDG_E_PARAM_TIMEOUT	0x13U
#define WDG_E_PARAM_POINTER	0x14U

/*
 *  ॢȸư
 */
#define WDG_RESET		0U
#define WDG_NMI			1U

#define WDG_INVALID_UINT16	(uint16) 0xffffU

/*
 *  [WDG152] ⥸塼
 */
#define WDG_UNINIT		0U
#define WDG_IDLE		1U
#define WDG_BUSY		2U

/*
 *  [WDG087] С
 */
#define WDG_AR_RELEASE_MAJOR_VERSION		4U
#define WDG_AR_RELEASE_MINOR_VERSION		0U
#define WDG_AR_RELEASE_REVISION_VERSION		3U

/*
 *  ץ饤С
 */
#define WDG_SW_MAJOR_VERSION				1U
#define WDG_SW_MINOR_VERSION				1U
#define WDG_SW_PATCH_VERSION				1U
#define WDG_VENDOR_ID						65U	/* NCES٥ID */

/*
 *  Wdg⥸塼ID
 */
#define WDG_MODULE_ID						102U

/*
 *  [WDG063][WDG148] DETΤ륵ӥID
 */
#define WdgServiceId_Init					0x00U
#define WdgServiceId_SetMode				0x01U
#define WdgServiceId_SetTriggerCondition	0x03U
#define WdgServiceId_GetVersionInfo			0x04U

/*
 *  [WDG013][WDG045][WDG064][WDG065][WDG066][WDG111] DET顼åޥ
 */
#if WDG_DEV_ERROR_DETECT != FALSE
#define WDG_CHECK_INITIALIZED(ApiId)													\
	do {																				\
		if (wdg_state != WDG_IDLE) {													\
			(void) Det_ReportError(WDG_MODULE_ID, 0x00U, (ApiId), WDG_E_DRIVER_STATE);	\
			goto error_exit;															\
		}																				\
	} while (0)

#define WDG_CHECK_INITIALIZED_ERCD(ApiId)												\
	do {																				\
		if (wdg_state != WDG_IDLE) {													\
			ercd = E_NOT_OK;															\
			(void) Det_ReportError(WDG_MODULE_ID, 0x00U, (ApiId), WDG_E_DRIVER_STATE);	\
			goto error_exit;															\
		}																				\
	} while (0)

#define WDG_CHECK_PARAM(exp, ApiId, ErrorId)											\
	do {																				\
		if (!(exp)) {																	\
			(void) Det_ReportError(WDG_MODULE_ID, 0x00U, (ApiId), (ErrorId));			\
			goto error_exit;															\
		}																				\
	} while (0)

#define WDG_CHECK_PARAM_ERCD(exp, ApiId, ErrorId)										\
	do {																				\
		if (!(exp)) {																	\
			ercd = E_NOT_OK;															\
			(void) Det_ReportError(WDG_MODULE_ID, 0x00U, (ApiId), (ErrorId));			\
			goto error_exit;															\
		}																				\
	} while (0)

#define WDG_SET_STATE(state)															\
	do {																				\
		wdg_state = state;																\
	} while (0)
#else /* WDG_DEV_ERROR_DETECT == FALSE */
#define WDG_CHECK_INITIALIZED(ApiId)
#define WDG_CHECK_INITIALIZED_ERCD(ApiId)
#define WDG_CHECK_PARAM(exp, ApiId, ErrorId)
#define WDG_CHECK_PARAM_ERCD(exp, ApiId, ErrorId)
#define WDG_SET_STATE(state)
#endif /* WDG_DEV_ERROR_DETECT != FALSE */

/*
 *  [WDG110] DEM顼åޥ
 */
#define WDG_CHECK_DEM_ERCD(exp, EventId)												\
	do {																				\
		if ((!(exp)) && ((EventId) != WDG_INVALID_UINT16)) {							\
			ercd = E_NOT_OK;															\
			Dem_ReportErrorStatus((EventId), DEM_EVENT_STATUS_PASSED);					\
		}																				\
	} while (0)

#define WDG_CHECK_DEM_EXIT_ERCD(exp, EventId)											\
	do {																				\
		if ((!(exp)) && ((EventId) != WDG_INVALID_UINT16)) {							\
			ercd = E_NOT_OK;															\
			Dem_ReportErrorStatus((EventId), DEM_EVENT_STATUS_PASSED);					\
			goto error_exit;															\
		}																				\
	} while (0)

typedef uint8	Wdg_TimeoutReactionType;

/*
 *  ȥꥬ֥å
 */
typedef struct trigger_control_block {
	WdgIf_ModeType	current_mode;		/* [WDG154] ߤΥåɥå⡼ */
	uint16			trigger_cnt;		/* [WDG153]ȥꥬ */
} TRIGGER_CB;

/*
 *  Wdg⡼ɽ֥å
 */
typedef struct wdg_mode_block {
	Wdg_TimeoutReactionType			WdgTimeoutReaction;	/* ॢȸư */
	uint8							WdgWindowOpenRate;	/* ɥץ */
	uint16							timeout;			/* ॢ */
	uint16							interrupt_period;	/* ߼ */
} WDG_MODE_INIB;

/*
 *  [WDG171] ե졼֥å
 */
typedef struct wdg_config_type {
	WdgIf_ModeType		WdgDefaultMode;		/* ǥեȥ⡼ */
	const WDG_MODE_INIB	*p_fast_mode_inib;	/* WdgFast⡼ɽ֥å */
	const WDG_MODE_INIB	*p_slow_mode_inib;	/* WdgSlow⡼ɽ֥å */
	TRIGGER_CB			*p_trigger_cb;		/* ȥꥬ֥å */
} Wdg_ConfigType;

/*
 *  Wdgƥॵӥץȥ
 */
extern void Wdg_Init(const Wdg_ConfigType *ConfigPtr);
extern Std_ReturnType Wdg_SetMode(WdgIf_ModeType WdgMode);
extern void Wdg_SetTriggerCondition(uint16 timeout);
extern void Wdg_GetVersionInfo(Std_VersionInfoType *versioninfo);

/*
 *  Wdgե졼(Wdg_Irq.c)
 */
extern const Wdg_ConfigType	*p_cur_wdg_config;

/*
 *  Wdg⡼ɽ֥å
 */
LOCAL_INLINE const WDG_MODE_INIB *
get_wdg_mode_inib(const WdgIf_ModeType mode)
{
	const WDG_MODE_INIB *current_mode;

	switch (mode) {
	case WDGIF_FAST_MODE:
		current_mode = p_cur_wdg_config->p_fast_mode_inib;
		break;
	case WDGIF_SLOW_MODE:
		current_mode = p_cur_wdg_config->p_slow_mode_inib;
		break;
	default:
		current_mode = NULL_PTR;
		break;
	}

	return(current_mode);
}

/*
 *  ʲ̤ݡȵǽ
 */
extern void Wdg_Cbk_GptNotification(void);

/*
 *  ̤ݡ
 *  - GPT
 *    <WDG163><WDG164><WDG165>
 *  - ʣåɥå
 *    <WDG169><WDG170><WDG172>
 *  - åɥå
 *    <WDG055><WDG076><WDG162><WDG077><WDG078>
 *  - 󥯥
 *    <WDG158>
 *  - ǥХåǽ
 *    <WDG149><WDG150><WDG151>
 *  - Off⡼ɥƥ
 *    <WDG122_Conf>
 *  - ͤǤϤʤ
 *    <WDG175>
 */

#endif /* WDG_H */
