#!ruby -Ke
#
#  TOPPERS/A-WDG
#      Automotive Watchdog Driver
#
#  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
#                             Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
#  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
#  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
#  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2014-2015 by Witz Corporation
#
#  ܥեȥϡֺ楷ƥʼץåȥե˴ؤ
#  륳󥽡෿ƱˤƳȯΤǤ롥ܥեȥ
#  ϡ嵭Ԥ˵°롥
#
#  $Id: check_spec_coverage.rb 1387 2015-06-04 05:33:35Z fsi-kaitori $
#

#
#  ͥХåå
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# оݥɽ
TAG_REG_ALL = "N?D?WDGa?[0-9][0-9][0-9][_Conf]*"

# WDG
aWdgSpecId = File.read("#{TOOL_ROOT}/wdg_spec_id.txt").split("\n")

# Ѥߥե
aImplSpecId = []
aFileData = File.read("#{TOOL_ROOT}/wdg_impl_id.txt").split("\n")
aFileData.each{|sLine|
  if (sLine =~ /\W#{TAG_REG_ALL}\W/)
    aImplSpecId.push(sLine.gsub(/^\W(#{TAG_REG_ALL})\W.*$/, "\\1"))
  end
}

# ̤
aNonImplTags = []
aWdgSpecId.each{|sTag|
  if (!aImplSpecId.include?(sTag))
    aNonImplTags.push(sTag)
  end
}

# ɽ
puts("=" * 30)
puts("Wdg spec tags   : #{aWdgSpecId.size()}")
puts("Implemented tags: #{aImplSpecId.size()}")
fCoverage = aImplSpecId.size().to_f() / aWdgSpecId.size().to_f() * 100
puts("Spec Coverage   : #{sprintf('%0.1f', fCoverage)} %")
puts("-" * 30)
puts("Not implementation tags: #{aNonImplTags.size()}")
puts("=" * 30)

aNonImplTags.each{|sTag|
  puts(sTag)
}

# ͤˤʤƤʤå
 aImplSpecId.each{|sTag|
  if (!aWdgSpecId.include?(sTag))
    puts("!! Not exist tag: #{sTag}")
  end
}

