/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: Wdg_Target.h 1551 2015-07-09 04:04:46Z suzuki-kawaguchi $
 */

#ifndef WDG_TARGET_H
#define WDG_TARGET_H

#include "SchM_Wdg.h"
#include "prc_sil.h"
#include "Std_Types.h"
#include "Wdg.h"

#define TIMER_CLOCK				(uint32) 60000U

#ifdef TOPPERS_USE_MULTICORE
/* åɥåޤΥ١ɥ쥹 */
#define WDGT_BASE				0x08020400U
/* åɥåޥȥꥬֹ */
#define WDGT_TRIGGER_IRQ		0x10012U
/* åɥåޥȥꥬΥ١ɥ쥹 */
#define WDGT_TRIGGER_BASE		(UINT_C(0x0c000200) + (UINT_C(0x00100000) * (((WDGT_TRIGGER_IRQ) >> UINT_C(16)) - UINT_C(1))) + (UINT_C(0x20) * (((WDGT_TRIGGER_IRQ) &UINT_C(0xffff)) - UINT_C(16))))
#else
/* åɥåޤΥ١ɥ쥹 */
#define WDGT_BASE				0x08000080U
/* åɥåޥȥꥬֹ */
#define WDGT_TRIGGER_IRQ		30U
/* åɥåޥȥꥬΥ١ɥ쥹 */
#define WDGT_TRIGGER_BASE		(0x08000000U + (0x00000020U * WDGT_TRIGGER_IRQ))
#endif /* TOPPERS_USE_MULTICORE */

#define WDGT_STATUS				0x00U
#define WDGT_CONTROL			0x04U
#define WDGT_PERIODL			0x08U
#define WDGT_PERIODH			0x0CU
#define WDGT_SNAPL				0x10U
#define WDGT_SNAPH				0x14U

/* ӥå */
#define WDGT_STATUS_TO			0x01U
#define WDGT_STATUS_RUN			0x02U
#define WDGT_CONTROL_ITO		0x01U
#define WDGT_CONTROL_CONT		0x02U
#define WDGT_CONTROL_START		0x04U
#define WDGT_CONTROL_STOP		0x08U

#define SIL_WRW_IOP_WDGT_TRIGGER_BASE(mem, data)	sil_wrw_iop((void *) (WDGT_TRIGGER_BASE + (mem)), (data))
#define SIL_WRW_IOP_WDGT_BASE(mem, data)			sil_wrw_iop((void *) (WDGT_BASE + (mem)), (data))

/* ѥ쥸ޥ */
#define WDGT_WR_TRIGGER_CONTROL(data)				SIL_WRW_IOP_WDGT_TRIGGER_BASE(WDGT_CONTROL, data)
#define WDGT_WR_TRIGGER_STATUS(data)				SIL_WRW_IOP_WDGT_TRIGGER_BASE(WDGT_STATUS, data)
#define WDGT_WR_TRIGGER_PERIODL(data)				SIL_WRW_IOP_WDGT_TRIGGER_BASE(WDGT_PERIODL, data)
#define WDGT_WR_TRIGGER_PERIODH(data)				SIL_WRW_IOP_WDGT_TRIGGER_BASE(WDGT_PERIODH, data)
#define WDGT_WR_CONTROL(data)						SIL_WRW_IOP_WDGT_BASE(WDGT_CONTROL, data)
#define WDGT_WR_STATUS(data)						SIL_WRW_IOP_WDGT_BASE(WDGT_STATUS, data)
#define WDGT_WR_PERIODL(data)						SIL_WRW_IOP_WDGT_BASE(WDGT_PERIODL, data)
#define WDGT_WR_PERIODH(data)						SIL_WRW_IOP_WDGT_BASE(WDGT_PERIODH, data)

/* ؿץȥ */
LOCAL_INLINE void wdg_trigger_init(uint16 wdg_interrupt_period);
LOCAL_INLINE void wdg_timer_init(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_trigger_terminate(void);
LOCAL_INLINE void wdg_trigger_int_clear(void);
LOCAL_INLINE void wdg_timer_terminate(void);
LOCAL_INLINE void wdg_timer_trigger(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_target_start(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE void wdg_target_off_mode(void);
LOCAL_INLINE void wdg_target_set_mode(const WDG_MODE_INIB *p_current_mode);
LOCAL_INLINE uint16 wdg_target_reset_timeout(uint16 trigger_cnt, uint16 pre_interrupt_period);

/*
 *  åɥåޥȥꥬߤεư
 */
LOCAL_INLINE void
wdg_trigger_init(uint16 wdg_interrupt_period)
{
	/*  */
	WDGT_WR_TRIGGER_CONTROL(WDGT_CONTROL_STOP);

	/* ॢȥơꥢ */
	WDGT_WR_TRIGGER_STATUS(0x00U);

	/* ޥȥꥬ߼ */
	/*  16bit */
	WDGT_WR_TRIGGER_PERIODL((wdg_interrupt_period * TIMER_CLOCK) & 0xffffU);
	/*  16bit */
	WDGT_WR_TRIGGER_PERIODH((wdg_interrupt_period * TIMER_CLOCK) >> 16U);

	/* ޳ϡȥɡߵ */
	WDGT_WR_TRIGGER_CONTROL(WDGT_CONTROL_START | WDGT_CONTROL_CONT | WDGT_CONTROL_ITO);

	return;
}

/*
 *  [WDG161] åɥå޵ư
 */
LOCAL_INLINE void
wdg_timer_init(const WDG_MODE_INIB *p_current_mode)
{
	/*  */
	WDGT_WR_CONTROL(WDGT_CONTROL_STOP);

	/* ॢȥơꥢ */
	WDGT_WR_STATUS(0x00U);

	/* ޼ */
	/*  16bit */
	WDGT_WR_PERIODL((p_current_mode->timeout * TIMER_CLOCK) & 0xffffU);
	/*  16bit */
	WDGT_WR_PERIODH((p_current_mode->timeout * TIMER_CLOCK) >> 16U);

	/* ޳ */
	WDGT_WR_CONTROL(WDGT_CONTROL_START);

	return;
}

/*
 *  åɥåޥȥꥬߤ߽
 */
LOCAL_INLINE void
wdg_trigger_terminate(void)
{
	/*  */
	WDGT_WR_TRIGGER_CONTROL(WDGT_CONTROL_STOP);

	/* ॢȥơꥢ */
	WDGT_WR_TRIGGER_STATUS(0x00U);

	return;
}

/*
 *  åɥåޥȥꥬ׵᥯ꥢ
 */
LOCAL_INLINE void
wdg_trigger_int_clear(void)
{
	/* ॢȥơꥢ */
	WDGT_WR_TRIGGER_STATUS(0x00U);

	return;
}

/*
 *  [WDG161] åɥå߽
 */
LOCAL_INLINE void
wdg_timer_terminate(void)
{
	/*  */
	WDGT_WR_CONTROL(WDGT_CONTROL_STOP);

	/* ॢȥơꥢ */
	WDGT_WR_STATUS(0x00U);

	return;
}

/*
 *  [WDG161] åɥåޥȥꥬ
 */
LOCAL_INLINE void
wdg_timer_trigger(const WDG_MODE_INIB *p_current_mode)
{
	/* [WDG040] ̵ */
	SchM_Enter_Wdg_Reentrant();

	/*  */
	WDGT_WR_CONTROL(WDGT_CONTROL_STOP);

	/* ޼ */
	/*  16bit */
	WDGT_WR_PERIODL((p_current_mode->timeout * TIMER_CLOCK) & 0xffffU);
	/*  16bit */
	WDGT_WR_PERIODH((p_current_mode->timeout * TIMER_CLOCK) >> 16U);

	/* ޳ */
	WDGT_WR_CONTROL(WDGT_CONTROL_START);

	/* [WDG040] ͭ */
	SchM_Exit_Wdg_Reentrant();

	return;
}

/*
 *  åɥå¸
 */
LOCAL_INLINE void
wdg_target_start(const WDG_MODE_INIB *p_current_mode)
{
	/* ޳ */
	wdg_timer_init(p_current_mode);

	/* ޥȥꥬ߳ */
	wdg_trigger_init(p_current_mode->interrupt_period);

	return;
}

/*
 *  åɥå¸off⡼
 */
LOCAL_INLINE void
wdg_target_off_mode(void)
{
	/*  */
	wdg_timer_terminate();

	/* ޥȥꥬ */
	wdg_trigger_terminate();

	return;
}

/*
 *  åɥå¸⡼
 */
LOCAL_INLINE void
wdg_target_set_mode(const WDG_MODE_INIB *p_current_mode)
{
	/*  */
	WDGT_WR_TRIGGER_CONTROL(WDGT_CONTROL_STOP);

	/* ॢȥơꥢ */
	WDGT_WR_TRIGGER_STATUS(0x00U);

	/* ޥȥꥬ߼ */
	/*  16bit */
	WDGT_WR_TRIGGER_PERIODL((p_current_mode->interrupt_period * TIMER_CLOCK) & 0xffffU);
	/*  16bit */
	WDGT_WR_TRIGGER_PERIODH((p_current_mode->interrupt_period * TIMER_CLOCK) >> 16U);

	/* ޳ϡȥɡߵ */
	WDGT_WR_TRIGGER_CONTROL(WDGT_CONTROL_START | WDGT_CONTROL_CONT | WDGT_CONTROL_ITO);

	return;
}

/*
 *  ॢȺ
 */
LOCAL_INLINE uint16
wdg_target_reset_timeout(uint16 trigger_cnt, uint16 pre_interrupt_period)
{
	uint16 timeout;

	if (trigger_cnt > 1U) {
		timeout = (trigger_cnt - 1) * pre_interrupt_period;
	}
	else if (trigger_cnt == 1U) {
		timeout = pre_interrupt_period;
	}
	else {
		timeout = 0U;
	}

	return(timeout);
}

/*
 *  ̤ݡ
 *  - ƥ١󥳡
 *    <WDG093><WDG094><WDG095>
 *  - ȥꥬ(ꥢɥ쥹)
 *    <WDG034>
 *  - 󥨥ꥢ(ROM or RAM)
 *    <WDG168>
 *  - ¸ȤʬΥΤ
 *    <WDG031>
 */

#endif /* WDG_TARGET_H */
