/*
 *  TOPPERS/A-WDGIF
 *      AuTomotive Watchdog Interface
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: WdgIf.h 1547 2015-07-08 03:48:31Z suzuki-kawaguchi $
 */

/* [WDGIF001][WDGIF002] WdgIf.h */

/*
 *  ȯ
 *  - [WDGIF003] WdgIfεǽWdgMξWdgΤ
 */

#ifndef WDGIF_H
#define WDGIF_H

/* [WDGIF034][WDGIF037][WDGIF041] */
#include "Os.h"
#include "Std_Types.h"
#include "WdgIf_Cfg.h"      /* [WDGIF050] */
#include "WdgIf_Types.h"    /* [WDGIF010][WDGIF047][WDGIF049] */

/*
 * DETΤ륵ӥID
 */
#define WdgIfServiceId_SetMode				0x01U
#define WdgIfServiceId_SetTriggerCondition	0x02U
#define WdgIfServiceId_GetVersionInfo		0x03U

/* [WDGIF006][WDGIF009][WDGIF030] 顼 */
#define WDGIF_E_PARAM_DEVICE				0x01U
#define WDGIF_E_INV_POINTER					0x02U

/* WDGIF⥸塼ID */
#define WDGIF_MODULE_ID						0x2bU

/* [WDGIF005] С */
#define WDGIF_AR_RELEASE_MAJOR_VERSION		4U
#define WDGIF_AR_RELEASE_MINOR_VERSION		0U
#define WDGIF_AR_RELEASE_REVISION_VERSION	3U

/* ץ饤С */
#define WDGIF_SW_MAJOR_VERSION				1U
#define WDGIF_SW_MINOR_VERSION				1U
#define WDGIF_SW_PATCH_VERSION				1U
#define WDGIF_VENDOR_ID						65U	/* NCES٥ID */

/*
 *  [WDGIF007][WDGIF031][WDGIF032][WDGIF048] åޥ
 */
#if WDGIF_DEV_ERROR_DETECT != FALSE
#define WDGIF_CHECK_PARAM(exp, ApiId, ErrorId)										\
	do {																			\
		if (!(exp)) {																\
			(void) Det_ReportError(WDGIF_MODULE_ID, 0x00U, (ApiId), (ErrorId));		\
			goto error_exit;														\
		}																			\
	} while (0)

#define WDGIF_CHECK_PARAM_ERCD(exp, ApiId, ErrorId)									\
	do {																			\
		if (!(exp)) {																\
			ercd = E_NOT_OK;														\
			(void) Det_ReportError(WDGIF_MODULE_ID, 0x00U, (ApiId), (ErrorId));		\
			goto error_exit;														\
		}																			\
	} while (0)
#else /* WDGIF_DEV_ERROR_DETECT == FALSE */
#define WDGIF_CHECK_PARAM(exp, ApiId, ErrorId)
#define WDGIF_CHECK_PARAM_ERCD(exp, ApiId, ErrorId)
#endif /* WDGIF_DEV_ERROR_DETECT != FALSE */

/*
 *  [WDGIF013][WDGIF017] WdgIfƥॵӥץȥ
 */
extern Std_ReturnType WdgIf_SetMode(uint8 DeviceIndex, WdgIf_ModeType WdgMode);
extern void WdgIf_SetTriggerCondition(uint8 DeviceIndex, uint16 Timeout);
extern void WdgIf_GetVersionInfo(Std_VersionInfoType *VersionInfoPtr);

/*
 * ǥХå
 * [WDGIF052][WDGIF053][WDGIF054][WDGIF055]
 */

/*
 * ñWdgΤߤб뤿ᡤʲλ̤ͤб
 * <WDGIF020>
 */

#endif /* WDGIF_H */
