/*
 *  TOPPERS/A-WDG
 *      Automotive Watchdog Driver
 *
 *  Copyright (C) 2014-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2014-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2014-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2014-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2014-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: os.c 1493 2015-06-30 00:48:17Z suzuki-kawaguchi $
 */

#include "Os.h"
#include "Wdg.h"
#include "Wdg_PBcfg.h"
#include "t_syslog.h"
#include "prc_sil.h"

/* DE2-115 */
#define KEY_BASE	0x08000400U
#define LED_G_BASE	0x08000420U
#define KEY_0		0x01U
#define KEY_1		0x02U
#define KEY_2		0x04U
#define KEY_3		0x08U

TASK(MainTask)
{
	boolean	trigger = FALSE;
	uint8	ercd;
	uint32	cur_key, pre_key = 0xFFFFU;

	syslog(LOG_NOTICE, "=== Wdg_Init ===");
	Wdg_Init(&wdg_config_WdgSettingsConfig_0);

	while (1) {
		cur_key = sil_rew_iop((void *) KEY_BASE);

		/* ܥ󲡲֤ܤΤ߽Ԥ */
		/* SLOW/FAST⡼ڴ */
		if (((pre_key & KEY_0) != 0U) && ((cur_key & KEY_0) == 0U)) {

			if (trigger == FALSE) {
				syslog(LOG_NOTICE, "[KEY0] Wdg_SetMode(WDGIF_SLOW_MODE)");
				ercd = Wdg_SetMode(WDGIF_SLOW_MODE);
				trigger = TRUE;
			}
			else {
				syslog(LOG_NOTICE, "[KEY0] Wdg_SetMode(WDGIF_FAST_MODE)");
				ercd = Wdg_SetMode(WDGIF_FAST_MODE);
				trigger = FALSE;
			}
			/* LED1 */
			sil_wrw_iop((void *) LED_G_BASE, 1U);
		}
		/* OFF⡼ڴ */
		else if (((pre_key & KEY_1) != 0U) && ((cur_key & KEY_1) == 0U)) {
			syslog(LOG_NOTICE, "[KEY1] Wdg_SetMode(WDGIF_OFF_MODE)");
			ercd = Wdg_SetMode(WDGIF_OFF_MODE);
			/* LED2 */
			sil_wrw_iop((void *) LED_G_BASE, 3U);
		}
		/* ȥꥬ */
		else if (((pre_key & KEY_2) != 0U) && ((cur_key & KEY_2) == 0U)) {
			syslog(LOG_NOTICE, "[KEY2] Wdg_SetTriggerCondition(5000U)");
			Wdg_SetTriggerCondition(5000U);
			/* LED3 */
			sil_wrw_iop((void *) LED_G_BASE, 7U);
		}
		/* ȥꥬ0 */
		else if (((pre_key & KEY_3) != 0U) && ((cur_key & KEY_3) == 0U)) {
			syslog(LOG_NOTICE, "[KEY3] Wdg_SetTriggerCondition(0U)");
			Wdg_SetTriggerCondition(0U);
			/* LED4 */
			sil_wrw_iop((void *) LED_G_BASE, 15U);
		}
		else {
			/* ⤷ʤ */
		}

		pre_key = cur_key;
	}

	ShutdownOS(E_OK);
}

ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	syslog(LOG_NOTICE, "## ProtectionHook is called !! (%d)", FatalError);

	return(PRO_SHUTDOWN);
}

sint32
main(void)
{
	StartOS(MainApp);
	while (1) ;
	return(0);
}
